import os
import pandas as pd
import serial
from serial.tools.list_ports import comports
import sys
import time

#read available devices, and allow choice if more than one
devs = comports()
if len(devs) > 1:
    for i,d in enumerate(devs):
        print(f'{i}: {d}')
    dev = devs[int(input('Select a device:'))]
elif len(devs) == 1:
    dev = devs[0]
else:
    print('No device detected')
    sys.exit(1)
print(f'Selected device: {dev}')

#open selected device
ser = serial.Serial(dev.device, 115200, timeout=1)
#sleep so connection can finish
time.sleep(2)

#set up data storage
data = []

#enter read loop
while True:
    try:
        line = ser.readline()   
        if line:
            string = line.decode()
            t = eval(string)
            data.append([int(p) for p in t])
            print(string)
    except:
        print('saving data')
        break

#create dataframe and save as csv
df = pd.DataFrame(data,columns=['force','rpm'])
df.to_csv('machinedata.csv',index=False)

#close serial connection
ser.close()
